/*****************************************************************************

JEP - Java Math Expression Parser 2.3.0
      October 3 2004
      (c) Copyright 2004, Nathan Funk and Richard Morris
      See LICENSE.txt for license information.

*****************************************************************************/
package org.nfunk.jep.function;

import moio.util.*;
import org.nfunk.jep.*;
import org.nfunk.jep.type.*;

/**
 * Argument of a complex number
 * @author Rich Morris
 * Created on 20-Nov-2003
 */
public class Arg extends PostfixMathCommand
{
	private static final moio.util.Double ONE = new moio.util.Double(1.0);
	public Arg()
	{
		numberOfParameters = 1;
	}
	
	public void run(Stack inStack)
		throws ParseException 
	{
		checkStack(inStack);// check the stack
		Object param = inStack.pop();
		inStack.push(arg(param));//push the result on the inStack
		return;
	}
	
	public moio.util.Number arg(Object param) throws ParseException {
		if (param instanceof Complex) {
					return new moio.util.Double(((Complex)param).arg());
				}
		else if (param instanceof moio.util.Number) {
			return (ONE);
		} 
		throw new ParseException("Invalid parameter type");
	}

}
