/*****************************************************************************

JEP - Java Math Expression Parser 2.3.0
      October 3 2004
      (c) Copyright 2004, Nathan Funk and Richard Morris
      See LICENSE.txt for license information.

*****************************************************************************/

package org.nfunk.jep.function;

import moio.util.*;
import org.nfunk.jep.*;

public class Logical extends PostfixMathCommand
{
	int id;
	public static final int AND = 0;
	public static final int OR = 1;
	public Logical(int id_in)
	{
		id = id_in;
		numberOfParameters = 2;
	}
	
	public void run(Stack inStack)
		throws ParseException 
	{
		checkStack(inStack);// check the stack
		
		Object param2 = inStack.pop();
		Object param1 = inStack.pop();
		
		
		if ((param1 instanceof moio.util.Number) && (param2 instanceof moio.util.Number))
		{
			double x = ((moio.util.Number)param1).doubleValue();
			double y = ((moio.util.Number)param2).doubleValue();
			int r;
			
			switch (id)
			{
				case 0:
					// AND
					r = ((x!=0d) && (y!=0d)) ? 1 : 0;
					break;
				case 1:
					// OR
					r = ((x!=0d) || (y!=0d)) ? 1 : 0;
					break;
				default:
					r = 0;
			}
			
			inStack.push(new moio.util.Double(r)); // push the result on the inStack
		}
		else
		{
			throw new ParseException("Invalid parameter type");
		}
		return;
	}
}
