/*****************************************************************************

JEP - Java Math Expression Parser 2.3.0
      October 3 2004
      (c) Copyright 2004, Nathan Funk and Richard Morris
      See LICENSE.txt for license information.

*****************************************************************************/

package org.nfunk.jep.function;

import moio.util.*;
import org.nfunk.jep.*;

/**
 * This class serves mainly as an example of a function that accepts any
 * number of parameters. Note that the numberOfParameters is initialized to 
 * -1.
 */
public class Sum extends PostfixMathCommand
{
	private Add addFun = new Add();
	/**
	 * Constructor.
	 */
	public Sum() {
		// Use a variable number of arguments
		numberOfParameters = -1;
	}
	
	/**
	 * Calculates the result of summing up all parameters, which are assumed
	 * to be of the moio.util.Double type.
	 */
	public void run(Stack stack) throws ParseException {
		
  		// Check if stack is null
  		if (null == stack) {
			throw new ParseException("Stack argument null");
		}
        
        Object param = stack.pop();
        moio.util.Number result;
		if (param instanceof moio.util.Number)
			result = (moio.util.Number) param;
		else 
			throw new ParseException("Invalid parameter type");
        
        // repeat summation for each one of the current parameters
        for(int i=1;i < curNumberOfParameters;++i)
        {
        	// get the parameter from the stack
            param = stack.pop();
            if (param instanceof moio.util.Number)   {
                // calculate the result
                result = addFun.add((moio.util.Number) param,result);
            } else {
                throw new ParseException("Invalid parameter type");
            }
                
            i++;
        }
        // push the result on the inStack
        stack.push(result);
	}
}
